c====================================================================
c
c		ggdelta
c
c====================================================================

      double precision function ggdelta(z,QQQ,wlo)
      implicit none 
      double precision QQQ,ggdelta_LO_exact,gg_n0_delta
	double precision gg_n1_delta,gg_n2_delta
      double precision z,ggdelta_NLO_exact
      integer wlo
	double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
	common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	!print*,WC0NNLO,WC1NNLO,WC2NNLO

	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			ggdelta = ggdelta_LO_exact(QQQ) 
     #				+ WC0LO * gg_n0_delta()
		case(1)
			ggdelta = ggdelta_NLO_exact(QQQ)
     #				+ WC1NLO * gg_n0_delta() 
     #				+ WC0NLO * gg_n1_delta() 
		case(2)
			ggdelta = WC2NNLO * gg_n0_delta() 
     #				+ WC1NNLO * gg_n1_delta()
     #				+ WC0NNLO * gg_n2_delta()
            end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			ggdelta =   WC0LO * gg_n0_delta()
		case(1)
			ggdelta =  WC1NLO * gg_n0_delta() 
     #				+ WC0NLO * gg_n1_delta() 
		case(2)
			ggdelta = WC2NNLO * gg_n0_delta() 
     #				+ WC1NNLO * gg_n1_delta()
     #				+ WC0NNLO * gg_n2_delta()
c	print*,'ggdelta NNLO = ',ggdelta
c	print*,'WC0NNLO=',WC0NNLO,'WC1NNLO=',WC1NNLO,'WC2NNLO=',WC2NNLO
c	print*,'n0=',gg_n0_delta(),'n1=',gg_n1_delta(),'n2=',gg_n2_delta()
		end select
	endif
	!print*,"ggdelta=",ggdelta,WC0LO,ggdelta_LO_exact(QQQ)
      
      end
c=========================================================================	
	double precision function ggdelta_LO_exact(QQQ)
	implicit none 
	double precision QQQ
	double complex sborn_mass	
	ggdelta_LO_exact = abs(sborn_mass(QQQ))**2
      !print*,ggdelta_LO_exact,"::"
	end
c=========================================================================	
	double precision function ggdelta_NLO_exact(QQQ)
	implicit none 
	double precision QQQ
	double complex sborn_mass,sum_q_born,sum_q_virtual_star
	double complex svirtual_mass	
	double precision L, Lt, Lr, NF, pi, z2, z3
      common /xsection/ L, Lt, Lr, NF 
      common /consts/ pi, z2, z3
	double precision b0,z4
	!note: beta_0 below HARDCODED with nf=5
	b0=23d0/12d0  
	z4=1.082323234d0
	sum_q_born =  sborn_mass(QQQ)
	sum_q_virtual_star = CONJG(svirtual_mass(QQQ))
c			Lr=log(mur**2/mhiggs**2)   L=log(muf**2/mhiggs**2)
	ggdelta_NLO_exact = abs(sum_q_born)**2  * (2d0*b0*(Lr-L) + pi**2)
     #     +	dreal(sum_q_born*sum_q_virtual_star)   
c      print*,"ratio ",ggdelta_NLO_exact/ ( abs(sum_q_born)**2  * 
c     #		(2d0*b0*(Lr-L) + pi**2)
c     #     +	abs(sum_q_born)**2  *11d0/2d0)     
c     #		+  abs(sum_q_born)**2  *11d0/2d0 
	!print*,sum_q_born,sum_q_virtual_star
	end
c=========================================================================	
	
	
	
	double precision function gg_n0_delta()
	implicit none
	
	gg_n0_delta=1d0
	end
c=========================================================================	
	double precision function gg_n1_delta()
	implicit double precision (t)
	double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	
	t2 = -0.11D2 / 0.2D1 + NF / 0.3D1
      gg_n1_delta = t2 * L - t2 * Lr + 6d0 * z2
	end
c=========================================================================	
	double precision function gg_n2_delta()
	implicit double precision (t)
	double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	z4=1.082323234d0
	
	
	
	t1 = NF ** 2
      t2 = t1 / 0.12D2
      t3 = 0.11D2 / 0.4D1 * NF
      t6 = L ** 2
      t20 = Lr ** 2
      t28 = z2 ** 2
      t37 = (t2 - t3 - dble(18 * z2) + 0.363D3 / 0.16D2) * t6 + ((-0.363
     #D3 / 0.8D1 - t1 / 0.6D1 + 0.11D2 / 0.2D1 * NF) * Lr + (dble(2 * z2
     #) - 0.1D1 / 0.4D1) * NF - dble(33 * z2) - 0.171D3 / 0.2D1 * z3 + 0
     #.3D1 / 0.4D1) * L + (0.363D3 / 0.16D2 + t2 - t3) * t20 + ((-0.19D2
     # / 0.12D2 - dble(3 * z2)) * NF + 0.51D2 / 0.4D1 + 0.99D2 / 0.2D1 *
     # dble(z2)) * Lr - dble(54 * t28) + 0.67D2 / 0.2D1 * dble(z2) - 0.1
     #65D3 / 0.4D1 * z3 + 0.1071D4 / 0.8D1 * z4 + 0.837D3 / 0.16D2 + (-0
     #.5D1 / 0.3D1 * dble(z2) + 0.5D1 / 0.6D1 * z3 - 0.247D3 / 0.36D2) *
     # NF
	

	gg_n2_delta = t37
	end

c====================================================================
c
c		ggplus
c
c====================================================================
      double precision function ggplus(z,QQQ,wlo)
      implicit none 
      double precision QQQ,ggplus_LO_exact
	double precision gg_n1_plus,gg_n2_plus
      double precision z
      integer wlo
	double complex sborn_mass
	double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
	common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			ggplus = 0d0
		case(1)
			ggplus = gg_n1_plus(z)* abs(sborn_mass(QQQ))**2 ! NLO exact
     #				+ WC0NLO * gg_n1_plus(z) 
		case(2)
			ggplus =  WC1NNLO * gg_n1_plus(z)
     #				+ WC0NNLO * gg_n2_plus(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			ggplus =   0d0
		case(1)
			ggplus =   WC0NLO * gg_n1_plus(z) 
		case(2)
			ggplus = WC1NNLO * gg_n1_plus(z)
     #				+ WC0NNLO * gg_n2_plus(z)
		end select

	endif
      end


c=========================================================================	
	double precision function gg_n1_plus(z)
	implicit none
	double precision L, Lt, Lr, NF,z
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	
      z4=1.082323234d0
	
	LLz = dlog(1d0-z)
	DD0=1d0
      DD1=LLz
	gg_n1_plus = -6d0*L*DD0+12d0*DD1
	
	end
c=========================================================================	
	
	
	double precision function gg_n2_plus(z)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,z
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	
      z4=1.082323234d0
	
	LLz = dlog(1d0-z)
	DD0=1d0
      DD1=LLz
	DD2=LLz**2
      DD3=LLz**3
	
	t3 = L ** 2
      t35 = ((0.165D3 / 0.4D1 - 0.5D1 / 0.2D1 * NF) * t3 + ((-0.99D2 / 0
     #.2D1 + 0.3D1 * NF) * Lr + dble(45 * z2) - 0.67D2 / 0.2D1 + 0.5D1 /
     # 0.3D1 * NF) * L + 0.351D3 / 0.2D1 * z3 + dble(33 * z2) - 0.101D3 
     #/ 0.3D1 + (-dble(2 * z2) + 0.14D2 / 0.9D1) * NF) * DD0 + (0.36D2 *
     # t3 + (-0.66D2 + 0.4D1 * NF) * L + (0.99D2 - 0.6D1 * NF) * Lr - 0.
     #10D2 / 0.3D1 * NF - dble(90 * z2) + 0.67D2) * DD1 + (-0.33D2 - 0.1
     #08D3 * L + 0.2D1 * NF) * DD2 + dble(72 * DD3)

	gg_n2_plus = t35

	
	end

c====================================================================
c
c		ggreg
c
c====================================================================

      double precision function ggreg(z,lambda,QQQ,wlo)
      implicit none 
      double precision QQQ,ggreg_exact_NLO
	double precision gg_n1_reg,gg_n2_reg
      double precision z,lambda
      integer wlo
	double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
	common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			ggreg = 0d0
		case(1)
			ggreg = ggreg_exact_NLO(z,lambda,QQQ)
     #				+ WC0NLO * gg_n1_reg(z) 
		case(2)
			ggreg =  WC1NNLO * gg_n1_reg(z)
     #				+ WC0NNLO * gg_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			ggreg =   0d0
		case(1)
			ggreg =   WC0NLO * gg_n1_reg(z) 
		case(2)
			ggreg = WC1NNLO * gg_n1_reg(z)
     #				+ WC0NNLO * gg_n2_reg(z)
		end select

	endif
      end
c=========================================================================	

      double precision function ggreg_exact_NLO(z,lambda,QQQ)
      implicit none 
      double precision z,lambda,QQQ
      double precision lambda_limit,born_squared
      double precision hard_ampl,pgg,collinear,hard,ggreg_effective
      double complex real_ggg_ampl1,real_ggg_ampl2,real_ggg_ampl3
      double complex real_ggg_ampl4
      double complex sum_over_quarks,sborn_mass
      external Aq1,Aq2a,Aq2b,Aq2c
	double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF

c     regular part of NLO Real corrections with massive quarks

c      ggreg_nlo = 1/2 * Nc * as/Pi * 
c               [ z^4 S_q{ S_i |real_ggg_ampl_i|^2  } - (1-z+z^2) * 2 * S_q {|born_q|^2} ]
c               -------------------------------------------------------------------------
c                           z * (1-z) * lambda * (1-lambda)
c
c     sum_over_quarks: sums over all massive quarks the function
c     that is passed to it as its first argument and it also 
c     multiplies by a normalization factor Wq(i)*3d0/32d0/QQQ**2
c     which is tau_q*3/32/m_higgs^2 
        
c        lambda=1e-10
         !call test_limits(QQQ)

         !call test_hard(QQQ)
	real_ggg_ampl1 =sum_over_quarks(Aq1,z,lambda,QQQ) 
	real_ggg_ampl2 =sum_over_quarks(Aq2a,z,lambda,QQQ)
	real_ggg_ampl3 =sum_over_quarks(Aq2b,z,lambda,QQQ)
	real_ggg_ampl4 =sum_over_quarks(Aq2c,z,lambda,QQQ)   
	hard_ampl = abs(real_ggg_ampl1)**2 + 
     #		abs(real_ggg_ampl2)**2 +
     #		abs(real_ggg_ampl3)**2 +
     #		abs(real_ggg_ampl4)**2
      
	born_squared = abs(sborn_mass(QQQ))**2  
      
	lambda_limit = (1d0-z+z**2)**2   *   born_squared
	hard =  3d0 *(1d0/2d0*z**4 * hard_ampl - lambda_limit ) 
     #              /z/(1d0-z)/lambda/(1d0-lambda)  
      !below: the regular piece coming from the integrated collinear counterterm
      !       and the renormalized PDF 
	pgg =1d0/z + z*(1d0-z) - 2d0
      
	collinear = born_squared  * 
     #                  ( 
     #                  6d0 * (pgg * dlog( (1d0-z)**2/z ) 
     #                          - dlog(z)/(1d0-z) 
     #                          )
     #                  -6d0*L*pgg
     #                  )
      
	ggreg_exact_NLO = hard + collinear  
c	ggreg_exact_NLO = collinear + born_squared*11d0/2d0*(z-1)**3/z          

c     test_limits compares the 1/2* z^4 * Sum_q{ | real_ggg_ampl1 |^2 } 
c     with (1-z+z^2) * born_ampl() 
c     at z=0.3, lambda=1e-10, and also lambda=1- 1e-10
c      call test_limits(QQQ)
      end


	
c=========================================================================	
	double precision function gg_n1_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	
	z4=1.082323234d0


	t1 = x ** 2
      t5 = 0.1D1 / x
      t6 = (t1 * x - t1 + 0.2D1 * x - 0.1D1) * t5
      t10 = (t1 - x + 0.1D1) ** 2
      t11 = x - 0.1D1
      t14 = log(x)
      t18 = t11 ** 2
      t22 = log(-t11)
      t25 = 0.6D1 * t6 * L + 0.6D1 * t10 / t11 * t5 * t14 + 0.11D2 / 0.2
     #D1 * t18 * t11 * t5 - 0.12D2 * t6 * t22

	gg_n1_reg = t25	
	end
c=========================================================================	
	
	
	double precision function gg_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	double precision Li2,Li3,S12
	z4=1.082323234d0
	t1 = x ** 2
      t2 = t1 * x
      t7 = 0.1D1 / x
      t10 = x + 0.1D1
      t11 = log(x)
      t16 = 0.17D2 * t1
      t21 = t1 ** 2
      t23 = 0.3D1 * t1
      t26 = x - 0.1D1
      t27 = 0.1D1 / t26
      t31 = 0.2D1 * x
      t33 = (t2 - t1 + t31 - 0.1D1) * t7
      t34 = log(-t26)
      t35 = t33 * t34
      t38 = L ** 2
      t41 = (t1 - x + 0.1D1) ** 2
      t42 = t41 * t27
      t43 = t7 * t11
      t44 = t42 * t43
      t46 = t26 ** 2
      t48 = t46 * t26 * t7
      t66 = t21 * x
      t68 = 0.7D1 * t2
      t69 = 0.18D2 * t1
      t72 = 0.1D1 / t10
      t73 = t27 * t72
      t74 = t11 ** 2
      t75 = t74 * t11
      t80 = 0.8D1 * t2
      t82 = 0.6D1 * x
      t85 = t7 * t34
      t86 = Li2(x)
      t90 = 0.2D1 * t21
      t95 = t72 * t11
      t96 = Li2(t1)
      t100 = 0.6D1 * t21
      t101 = 0.11D2 * t2
      t102 = 0.12D2 * x
      t105 = t7 * t74
      t119 = 0.4D1 * t21
      t120 = 0.21D2 * t1
      t121 = 0.14D2 * x
      t122 = t119 + t80 + t120 + t121 + 0.7D1
      t124 = log(t10)
      t135 = t34 ** 2
      t140 = t23 + t31 + 0.1D1
      t142 = t72 * t96
      t153 = S12(x)
      t165 = t124 ** 2
      t176 = Li3(x)
      t184 = (t101 + t120 - t102 - 0.14D2) * t7
      t187 = (((0.37D2 * t2 - 0.51D2 * t1 + 0.96D2 * x - 0.37D2) * t7 / 
     #0.18D2 + 0.2D1 / 0.3D1 * t11 * t10) * NF + 0.3D1 / 0.4D1 * (0.33D2
     # * t2 - t16 - 0.38D2 * x - 0.33D2) * t7 + 0.18D2 * (t21 - 0.4D1 * 
     #t2 + t23 + 0.1D1) * t7 * t27 * t11 - 0.36D2 * t35) * t38 + ((-0.3D
     #1 * t44 - 0.11D2 / 0.4D1 * t48 + 0.6D1 * t35) * NF + 0.99D2 / 0.2D
     #1 * t44 + 0.363D3 / 0.8D1 * t48 - 0.99D2 * t35) * Lr + (0.21165D5 
     #* t2 - 0.19751D5 * t1 + 0.18523D5 * x - 0.18321D5) * t7 / 0.48D2 +
     # 0.3D1 / 0.2D1 * (0.7D1 * x - 0.17D2 * t21 + 0.9D1 * t66 - t68 + t
     #69 + 0.4D1) * t7 * t73 * t75 - 0.9D1 / 0.2D1 * (0.3D1 * t21 - t80 
     #+ 0.9D1 * t1 - t82 + 0.3D1) * t27 * t85 * t86 + 0.9D1 / 0.4D1 * (t
     #90 - 0.15D2 * t1 - 0.10D2 * x - 0.5D1) * t7 * t95 * t96 - 0.9D1 * 
     #(t100 - t101 + t69 - t102 + 0.6D1) * t27 * t105 * t34 - 0.3D1 / 0.
     #4D1 * (0.1227D4 * t1 - 0.1180D4 * t2 + 0.605D3 * t21 - 0.1238D4 * 
     #x + 0.641D3) * t7 * t27 * t34 * t11 - 0.9D1 * t122 * t7 * t72 * t1
     #24 * t86 + 0.9D1 / 0.4D1 * (0.59D2 * t21 - 0.116D3 * t2 + 0.177D3 
     #* t1 - 0.118D3 * x + 0.59D2) * t27 * t7 * t135 * t11 + 0.27D2 / 0.
     #2D1 * t140 * t7 * t142 * t124 + 0.9D1 / 0.2D1 * (-0.57D2 * t2 + 0.
     #59D2 * x + 0.53D2 * t1 + 0.5D1 * t66 - 0.51D2 * t21 - 0.11D2) * t7
     # * t73 * t153 - 0.9D1 / 0.4D1 * (t119 + t80 + 0.27D2 * t1 + 0.18D2
     # * x + 0.9D1) * t72 * t105 * t124 + 0.27D2 / 0.2D1 * t140 * t72 * 
     #t43 * t165 - 0.9D1 / 0.2D1 * (-0.78D2 * t21 - 0.29D2 * t2 + 0.35D2
     # * x + 0.6D1 * t66 + 0.75D2 * t1 + 0.27D2) * t7 * t73 * t176 - 0.7
     #2D2 * t33 * t135 * t34 + 0.3D1 / 0.4D1 * t184 * t96
      t202 = 0.6D1 * t2
      t208 = t72 * z2
      t218 = t7 * z2
      t238 = t7 * t86
      t262 = (t1 + 0.1D1 + x) ** 2
      t263 = t262 * t72
      t264 = S12(t1)
      t269 = S12(-x)
      t273 = 0.8D1 * t21
      t276 = Li3(t1)
      t299 = 0.52D2 * x
      t321 = 0.61D2 * x
      t364 = t43 * t34
      t390 = (-0.3D1 * t33 * NF + 0.99D2 / 0.2D1 * t33) * Lr + (-(0.122D
     #3 * t2 + 0.195D3 * t1 - 0.186D3 * x - 0.86D2) * t7 / 0.27D2 - 0.8D
     #1 / 0.3D1 * t10 * z2 + (t90 + t68 + 0.60D2 * t1 - t321 + 0.10D2) *
     # t27 * t43 / 0.9D1 - 0.4D1 / 0.9D1 * (0.5D1 * t2 - 0.12D2 * t1 + 0
     #.21D2 * x - 0.5D1) * t7 * t34 + 0.8D1 / 0.3D1 * t10 * t86 + 0.4D1 
     #/ 0.3D1 * t10 * t74) * NF + (0.899D3 * t2 - 0.212D3 * t1 + 0.346D3
     # * x - 0.899D3) * t7 / 0.4D1 - 0.9D1 * (t100 - 0.14D2 * t2 - 0.24D
     #2 * t1 - 0.9D1 * x - 0.4D1) * t7 * t208 + 0.3D1 / 0.2D1 * (0.154D3
     # * t21 - 0.287D3 * t2 + 0.180D3 * t1 - 0.113D3 * x + 0.44D2) * t27
     # * t43 - 0.3D1 * (0.77D2 * t2 - 0.83D2 * t1 + t321 - 0.77D2) * t7 
     #* t34 - 0.126D3 * t42 * t364 - 0.18D2 * t263 * t43 * t124 + 0.18D2
     # * (t21 - t202 - 0.13D2 * t1 - t82 + 0.1D1) * t7 * t72 * t86 - 0.9
     #D1 * t262 * t7 * t142 + 0.9D1 * (0.8D1 * t1 - 0.3D1 * t2 - t273 + 
     #0.3D1 * t66 + 0.2D1 + 0.3D1 * x) * t7 * t73 * t74 + 0.108D3 * t33 
     #* t135
      t397 = (t1 - t31 + 0.2D1) * t7
      t409 = 0.132D3 * t21
      t486 = -(t16 + t121 + 0.2D1) * t7 * z3 / 0.6D1 - t397 * t74 * t34 
     #/ 0.24D2 + 0.5D1 / 0.9D1 * t10 * t75 + (0.1570D4 * t2 - 0.249D3 * 
     #t1 + 0.294D3 * x - 0.1282D4) * t7 * t34 / 0.108D3 - (t409 - 0.351D
     #3 * t2 + 0.117D3 * t1 + t299 + 0.68D2) * t27 * t105 / 0.72D2 + t39
     #7 * t135 * t11 / 0.24D2 + (0.68D2 * t21 - 0.87D2 * t2 + 0.63D2 * t
     #1 - 0.82D2 * x + 0.68D2) * t27 * t364 / 0.12D2 - 0.4D1 * t10 * z2 
     #* t11 - t397 * t34 * z2 / 0.12D2 - (0.31D2 * t1 + 0.34D2 * x - 0.2
     #D1) * t7 * t176 / 0.12D2 + (0.47D2 * t1 + 0.50D2 * x - 0.2D1) * t7
     # * t11 * t86 / 0.12D2 + t397 * t34 * t86 / 0.12D2 + (t119 + 0.227D
     #3 * t2 + t120 - 0.302D3 * x + 0.68D2) * t27 * t238 / 0.36D2 - (0.1
     #7774D5 * t2 - 0.3801D4 * t1 + 0.2982D4 * x - 0.14939D5) * t7 / 0.1
     #296D4 + (0.65D2 * t1 + 0.62D2 * x + 0.2D1) * t7 * t153 / 0.12D2 + 
     #(t409 - 0.387D3 * t2 + 0.99D2 * t1 + 0.70D2 * x + 0.68D2) * t27 * 
     #t218 / 0.36D2 - (0.2384D4 * t21 - 0.3041D4 * t2 + 0.333D3 * t1 - 0
     #.598D3 * x + 0.1282D4) * t27 * t43 / 0.216D3 - 0.2D1 / 0.9D1 * (0.
     #17D2 * t2 - t23 + t102 - 0.17D2) * t7 * t135
      t488 = -(0.2295D4 * t2 - 0.1894D4 * t1 + 0.2159D4 * x - 0.2295D4) 
     #* t7 * t34 / 0.4D1 + 0.3D1 * (0.110D3 * t2 - 0.116D3 * t1 + 0.127D
     #3 * x - 0.110D3) * t7 * t135 - 0.9D1 * (t69 - t202 - 0.19D2 * t21 
     #+ 0.10D2 * t66 + 0.2D1 + t82) * t7 * t27 * t208 * t11 - 0.3D1 / 0.
     #4D1 * (0.495D3 * t21 - 0.886D3 * t2 + 0.564D3 * t1 - 0.244D3 * x +
     # 0.60D2) * t27 * t218 + 0.9D1 / 0.2D1 * (0.59D2 * t1 + 0.11D2 * t6
     #6 + 0.31D2 * x - 0.65D2 * t21 + 0.11D2 - 0.25D2 * t2) * t7 * t27 *
     # t95 * t86 + 0.3D1 / 0.4D1 * (0.121D3 * t21 - 0.300D3 * t2 + 0.87D
     #2 * t1 + 0.398D3 * x - 0.317D3) * t27 * t238 + (0.4054D4 * t21 - 0
     #.6427D4 * t2 + 0.5655D4 * t1 - 0.5083D4 * x + 0.2069D4) * t27 * t4
     #3 / 0.8D1 + 0.3D1 / 0.2D1 * t184 * t11 * t124 + 0.3D1 / 0.8D1 * (-
     #0.827D3 * t2 + 0.699D3 * t1 + 0.374D3 * t21 - 0.389D3 * x + 0.154D
     #3) * t7 * t27 * t74 - 0.18D2 * t263 * t7 * t264 + 0.9D1 * t122 * t
     #72 * t7 * t269 - 0.9D1 / 0.8D1 * (t273 + t80 - t23 - t31 - 0.1D1) 
     #* t7 * t72 * t276 + 0.9D1 / 0.2D1 * (t273 + 0.16D2 * t2 + 0.33D2 *
     # t1 + 0.22D2 * x + 0.11D2) * t72 * t7 * t124 * z2 + 0.9D1 / 0.2D1 
     #* (0.23D2 * t21 - 0.48D2 * t2 + 0.69D2 * t1 - 0.66D2 * x + 0.23D2)
     # * t27 * t85 * z2 - 0.9D1 / 0.2D1 * (-0.20D2 * t1 - t299 + 0.3D1 +
     # 0.33D2 * t66 - 0.15D2 * t21 + 0.13D2 * t2) * t7 * t73 * z3 + t390
     # * L + t486 * NF
      t489 = t187 + t488


	gg_n2_reg = t489

	end



c====================================================================
c
c		qgreg
c
c====================================================================	

      double precision function qgreg(z,lambda,QQQ,wlo)
      implicit none 
      double precision QQQ,qgreg_NLO_exact
	double precision qg_n1_reg,qg_n2_reg
      double precision z,lambda
      integer wlo
	double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
	common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qgreg = 0d0
		case(1)
			qgreg = qgreg_NLO_exact(z,lambda,QQQ)
     #				+ WC0NLO * qg_n1_reg(z) 
		case(2)
			qgreg =  WC1NNLO * qg_n1_reg(z)
     #				+ WC0NNLO * qg_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qgreg =   0d0
		case(1)
			qgreg =   WC0NLO * qg_n1_reg(z) 
		case(2)
			qgreg = WC1NNLO * qg_n1_reg(z)
     #				+ WC0NNLO * qg_n2_reg(z)
		end select

	endif
      end


c=========================================================================	

	double precision function qgreg_NLO_exact(z,lambda,QQQ)
      implicit none 
      double precision z,QQQ,lambda
      double precision qgreg_effective
	double precision L, Lt, Lr,NF
	double precision pi, z2, z3
	common /xsection/ L, Lt, Lr, NF 
      common /consts/ pi, z2, z3
	double complex sum_Aqqgh,sborn_mass
	double precision Cf,Pgq,born_squared,ysp
	double precision term1,term2,sum_Aqqgh_lambda

	Cf= 4d0/3d0
	Pgq = Cf/2d0*(1d0+(1d0-z)**2)/z
	born_squared = abs(sborn_mass(QQQ))**2
	ysp = -(1d0-z)*(1d0-lambda)
	sum_Aqqgh_lambda=abs(sum_Aqqgh(1d0/ysp,QQQ))**2
		
	term1 = born_squared * (Cf/2d0*z 
     $				- Pgq * dlog(z/(1-z)**2)
     $				- Pgq * L) !L=log(muf**2/mH**2)
	term2 = (
     $			sum_Aqqgh_lambda * (1d0+(1d0-z)**2*lambda)/z
     $			- born_squared     * (1d0+(1d0-z)**2)/z 
     $			)
     $			/(1d0-lambda)
	qgreg_NLO_exact =  (term1+term2)
	
		   
      end



c=========================================================================	
	double precision function qg_n1_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	z4=1.082323234d0
	

	t1 = x ** 2
      t4 = 0.1D1 / x
      t5 = (t1 - 0.2D1 * x + 0.2D1) * t4
      t12 = log(x)
      t16 = log(0.1D1 - x)
      t19 = -0.2D1 / 0.3D1 * t5 * L - (t1 - 0.6D1 * x + 0.3D1) * t4 / 0.
     #3D1 - 0.2D1 / 0.3D1 * t5 * t12 + 0.4D1 / 0.3D1 * t5 * t16


	qg_n1_reg = t19	
	
	end
	
	
	
	
c=========================================================================	
	double precision function qg_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	double precision Li2,Li3,S12

		
	z4=1.082323234d0
	t1 = x ** 2
      t4 = t1 * x
      t7 = 0.1D1 / x
      t13 = 0.784D3 * t4
      t17 = log(0.1D1 - x)
      t25 = log(x)
      t26 = t25 ** 2
      t33 = Li3(x)
      t50 = 0.2D1 * x
      t52 = (t1 - t50 + 0.2D1) * t7
      t53 = t17 ** 2
      t59 = 0.33D2 * t1
      t61 = (0.4D1 * t4 + 0.222D3 * x + 0.166D3 + t59) * t7
      t62 = Li2(-x)
      t66 = (t1 + t50 + 0.2D1) * t7
      t67 = S12(-x)
      t74 = S12(x)
      t77 = Li3(t1)
      t80 = S12(t1)
      t95 = Li2(x)
      t104 = t52 * NF
      t118 = t52 * t17
      t121 = L ** 2
      t129 = t52 * t53
      t133 = t25 * t17
      t134 = t52 * t133
      t142 = 0.418D3 * x
      t149 = -(-0.144D3 * t1 - 0.221D3 + 0.738D3 * x + 0.292D3 * t4) * t
     #7 * z2 / 0.27D2 - (0.14796D5 * x + 0.3834D4 * t1 + t13 - 0.21295D5
     #) * t7 * t17 / 0.162D3 + (0.226D3 * t4 + 0.1464D4 * x - 0.234D3 * 
     #t1 - 0.837D3) * t7 * t26 / 0.54D2 + (0.339D3 * t1 + 0.302D3 + 0.47
     #4D3 * x) * t7 * t33 / 0.9D1 + (-0.22042D5 + 0.26424D5 * x + 0.2464
     #D4 * t4 + 0.7143D4 * t1) * t7 * t25 / 0.324D3 - (0.142D3 * x + 0.1
     #45D3 * t1 + 0.108D3) * t7 * t26 * t25 / 0.54D2 + 0.367D3 / 0.54D2 
     #* t52 * t53 * t17 - t61 * t62 / 0.27D2 + 0.8D1 * t66 * t67 - (0.26
     #9D3 * t1 + 0.614D3 * x + 0.74D2) * t7 * t74 / 0.9D1 + t66 * t77 / 
     #0.2D1 - 0.2D1 * t66 * t80 + t7 * (-0.2592D4 + 0.111D3 * t1 + 0.288
     #D3 * t4 + 0.2278D4 * x) * t53 / 0.36D2 + (0.2605D4 - 0.711D3 * t1 
     #- 0.876D3 * x + 0.148D3 * t4) * t7 * t95 / 0.54D2 + 0.2D1 / 0.9D1 
     #* (0.46D2 + 0.45D2 * t1 - 0.81D2 * x) * t7 * z3 + (-0.2D1 / 0.9D1 
     #* t104 + (0.91D2 * t1 + 0.92D2 * x - 0.147D3 + 0.36D2 * t4) * t7 /
     # 0.18D2 - 0.2D1 / 0.9D1 * (0.28D2 * t1 + 0.25D2 * x + 0.27D2) * t7
     # * t25 + 0.31D2 / 0.9D1 * t118) * t121 + ((0.29D2 - 0.38D2 * x + 0
     #.19D2 * t1) * t7 * t25 / 0.27D2 + t129 / 0.18D2 + t52 * t26 / 0.9D
     #1 - 0.2D1 / 0.9D1 * t134 - (0.9D1 * t1 - 0.16D2 * x + 0.13D2) * t7
     # * t17 / 0.9D1 + (0.265D3 - t142 + 0.179D3 * t1) * t7 / 0.162D3) *
     # NF
      t152 = (t1 - 0.6D1 * x + 0.3D1) * t7
      t154 = t52 * t25
      t208 = log(x + 0.1D1)
      t209 = t25 * t208
      t227 = (t104 / 0.3D1 - 0.11D2 / 0.2D1 * t52) * Lr + ((0.31D2 - 0.2
     #2D2 * x + 0.29D2 * t1) * t7 / 0.54D2 - t154 / 0.9D1 + 0.4D1 / 0.9D
     #1 * t118) * NF + (-0.19549D5 + 0.10602D5 * x + 0.4293D4 * t1 + t13
     #) * t7 / 0.324D3 + 0.2D1 / 0.9D1 * (0.62D2 + 0.89D2 * t1 + 0.128D3
     # * x) * t7 * z2 + (t59 + 0.1470D4 * x - 0.1080D4 + 0.400D3 * t4) *
     # t7 * t25 / 0.54D2 - (t142 + 0.72D2 * t4 - 0.489D3 + 0.101D3 * t1)
     # * t7 * t17 / 0.9D1 + 0.106D3 / 0.9D1 * t134 - 0.2D1 * t66 * t209 
     #- 0.2D1 / 0.9D1 * (0.46D2 + 0.162D3 * x + 0.81D2 * t1) * t7 * t95 
     #- (0.64D2 * x + 0.54D2 + 0.67D2 * t1) * t7 * t26 / 0.9D1 - 0.31D2 
     #/ 0.3D1 * t129 - 0.2D1 * t66 * t62
      t265 = t208 ** 2
      t282 = ((t152 / 0.6D1 + t154 / 0.3D1 - 0.2D1 / 0.3D1 * t118) * NF 
     #- 0.11D2 / 0.4D1 * t152 - 0.11D2 / 0.2D1 * t154 + 0.11D2 * t118) *
     # Lr + (-0.199423D6 + 0.6148D4 * t4 + 0.176196D6 * x + 0.10743D5 * 
     #t1) * t7 / 0.1944D4 + t227 * L + 0.107D3 / 0.18D2 * t52 * t26 * t1
     #7 - 0.115D3 / 0.9D1 * t52 * t53 * t25 + t52 * t17 * t95 + 0.4D1 * 
     #t66 * t62 * t208 - 0.4D1 * t66 * t25 * t62 - 0.4D1 * t66 * t208 * 
     #t95 - (0.214D3 + 0.446D3 * x + 0.281D3 * t1) * t7 * t25 * t95 / 0.
     #9D1 - t61 * t209 / 0.27D2 - (-0.5935D4 + 0.4956D4 * x + 0.652D3 * 
     #t4 + 0.363D3 * t1) * t7 * t133 / 0.54D2 - 0.3D1 * t66 * t26 * t208
     # + 0.2D1 * t66 * t25 * t265 + 0.4D1 / 0.9D1 * (0.32D2 * t1 + 0.13D
     #2 + 0.35D2 * x) * t7 * z2 * t25 + 0.6D1 * t66 * z2 * t208 - 0.59D2
     # / 0.9D1 * t52 * t17 * z2
      t283 = t149 + t282

	qg_n2_reg = t283
	end


c====================================================================
c
c		qqbreg
c
c====================================================================	

      double precision function qqbreg(z,QQQ,wlo)
      implicit none 
      double precision QQQ,qqbreg_NLO_exact
	double precision qqb_n1_reg,qqb_n2_reg
      double precision z
      integer wlo
	double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
	common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qqbreg = 0d0
		case(1)
			qqbreg = qqbreg_NLO_exact(z,QQQ)
     #				+ WC0NLO * qqb_n1_reg(z) 
		case(2)
			qqbreg =  WC1NNLO * qqb_n1_reg(z)
     #				+ WC0NNLO * qqb_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qqbreg =   0d0
		case(1)
			qqbreg =   WC0NLO * qqb_n1_reg(z) 
		case(2)
			qqbreg = WC1NNLO * qqb_n1_reg(z)
     #				+ WC0NNLO * qqb_n2_reg(z)
		end select

	endif
      end

c=========================================================================	

      double precision function qqbreg_NLO_exact(z,QQQ)
      implicit none 
      double precision z
      double precision QQQ
	double complex sum_Aqqgh
	qqbreg_NLO_exact =  32d0/27d0 * (1d0-z)**3 /z
     $			*abs(sum_Aqqgh(z,QQQ))**2

      end


c=========================================================================	
	double precision function qqb_n1_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	z4=1.082323234d0
	

	t1 = x - 0.1D1
      t2 = t1 ** 2
      t7 = -0.32D2 / 0.27D2 * t2 * t1 / x
	
	qqb_n1_reg = t7
	
	end
c=========================================================================	
	double precision function qqb_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3	
	double precision Li2,Li3,S12
	z4=1.082323234d0
	
	t1 = x ** 2
      t4 = 0.32D2 / 0.27D2 + 0.32D2 / 0.9D1 * t1 + 0.16D2 / 0.27D2 * x
      t5 = Li2(-x)
      t8 = (x + 0.2D1) ** 2
      t9 = 0.1D1 / x
      t10 = t8 * t9
      t11 = log(x)
      t15 = x - 0.1D1
      t20 = L ** 2
      t22 = t1 * x
      t30 = t15 ** 2
      t32 = t30 * t15 * t9
      t33 = log(-t15)
      t67 = t9 * t33
      t70 = Li2(x)
      t73 = t11 ** 2
      t87 = (t1 + 0.2D1 * x + 0.2D1) * t9
      t89 = log(x + 0.1D1)
      t99 = t89 ** 2
      t116 = t33 ** 2
      t120 = t4 * t5 + (-0.4D1 / 0.9D1 * t11 * t10 + 0.8D1 / 0.9D1 * (x 
     #+ 0.3D1) * t15 * t9) * t20 + (0.16D2 / 0.81D2 * (0.4D1 * t22 - 0.3
     #D1 - 0.12D2 * t1 + 0.15D2 * x) * t9 * t11 - 0.32D2 / 0.81D2 * t32 
     #* t33 + 0.8D1 / 0.243D3 * (0.41D2 * t1 - 0.88D2 * x + 0.23D2) * t1
     #5 * t9) * NF + (0.16D2 / 0.27D2 * t32 * NF - 0.88D2 / 0.9D1 * t32)
     # * Lr + (0.2D1 / 0.81D2 * t15 * (0.263D3 * x + 0.459D3) * t9 + 0.1
     #6D2 / 0.9D1 * t10 * z2 - 0.4D1 / 0.81D2 * (-0.141D3 * t1 + 0.64D2 
     #* t22 + 0.24D2 * x + 0.108D3) * t9 * t11 + 0.32D2 / 0.81D2 * t15 *
     # (0.8D1 * t1 - 0.25D2 * x - 0.19D2) * t67 - 0.16D2 / 0.9D1 * t10 *
     # t70 - 0.4D1 / 0.9D1 * t10 * t73) * L + 0.8D1 / 0.81D2 * (0.10D2 *
     # t22 + 0.12D2 - 0.87D2 * t1 + 0.42D2 * x) * t9 * t70 - 0.16D2 / 0.
     #27D2 * t87 * t5 * t89 + 0.8D1 / 0.9D1 * t87 * t11 * t5 + 0.4D1 / 0
     #.9D1 * t87 * t73 * t89 - 0.8D1 / 0.27D2 * t87 * t99 * t11 - 0.8D1 
     #/ 0.3D1 * t10 * t11 * t70 + 0.4D1 / 0.81D2 * t15 * (0.384D3 * t1 -
     # 0.967D3 * x - 0.75D2) * t67 - 0.32D2 / 0.81D2 * t15 * (0.13D2 * t
     #1 - 0.35D2 * x - 0.14D2) * t9 * t116
      t141 = S12(-x)
      t151 = S12(x)
      t156 = Li3(-x)
      t159 = Li3(x)
      t180 = -0.8D1 / 0.27D2 * t87 * z2 * t89 + 0.8D1 / 0.9D1 * t10 * z2
     # * t11 - 0.2D1 / 0.81D2 * (0.135D3 - 0.2111D4 * t1 + 0.1448D4 * x 
     #+ 0.768D3 * t22) * t9 * t11 + 0.16D2 / 0.81D2 * (0.5D1 - 0.102D3 *
     # t1 + 0.75D2 * x + 0.47D2 * t22) * t9 * z2 - 0.16D2 / 0.27D2 * t87
     # * t141 - 0.8D1 / 0.81D2 * (0.27D2 + 0.44D2 * t22 + 0.39D2 * x - 0
     #.81D2 * t1) * t9 * t73 - 0.32D2 / 0.9D1 * t10 * t151 + t4 * t11 * 
     #t89 - 0.8D1 / 0.9D1 * t87 * t156 + 0.32D2 / 0.9D1 * t10 * t159 - 0
     #.4D1 / 0.81D2 * t15 * (0.651D3 * t1 - 0.1661D4 * x + 0.241D3) * t9
     # - 0.4D1 / 0.27D2 * t10 * t73 * t11 - 0.16D2 / 0.27D2 * t87 * z3 +
     # 0.16D2 / 0.81D2 * t15 * (0.37D2 * t1 - 0.101D3 * x - 0.44D2) * t6
     #7 * t11
      t181 = t120 + t180

	qqb_n2_reg = t181
	end

c====================================================================
c
c		qqreg
c
c====================================================================		

      double precision function qqreg(z,wlo)
      implicit none 
	double precision qq_n2_reg
      double precision z
      integer wlo
	double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
	common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qqreg = 0d0
		case(1)
			qqreg = 0d0 
		case(2)
			qqreg =   WC0NNLO * qq_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qqreg =   0d0
		case(1)
			qqreg =   0d0 
		case(2)
			qqreg =  WC0NNLO * qq_n2_reg(z)
		end select

	endif
      end



	
c=========================================================================	
	double precision function qq_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3	
	double precision Li2,Li3,S12

	t2 = (x + 0.2D1) ** 2
      t3 = 0.1D1 / x
      t4 = t2 * t3
      t5 = log(x)
      t9 = x - 0.1D1
      t10 = (x + 0.3D1) * t9
      t14 = L ** 2
      t16 = Li2(x)
      t19 = t5 ** 2
      t22 = x ** 2
      t23 = 0.5D1 * t22
      t29 = log(-t9)
      t30 = t3 * t29
      t37 = (0.5D1 * x + 0.17D2) * t9
      t48 = 0.4D1 * x
      t57 = Li3(x)
      t60 = S12(x)
      t68 = (t22 - 0.2D1 * x + 0.2D1) * t3
      t90 = t29 ** 2
      t108 = (-0.4D1 / 0.9D1 * t4 * t5 + 0.8D1 / 0.9D1 * t10 * t3) * t14
     # + (-0.16D2 / 0.9D1 * t4 * t16 - 0.4D1 / 0.9D1 * t4 * t19 + 0.4D1 
     #/ 0.9D1 * (-0.12D2 + t23 + 0.8D1 * x) * t3 * t5 - 0.32D2 / 0.9D1 *
     # t10 * t30 + 0.16D2 / 0.9D1 * t4 * z2 + 0.2D1 / 0.3D1 * t37 * t3) 
     #* L - 0.16D2 / 0.27D2 * (0.17D2 * x + t23 + 0.19D2) * t3 * t5 * t1
     #6 - 0.8D1 / 0.9D1 * (t48 + t22 - 0.6D1) * t3 * t16 + 0.8D1 / 0.27D
     #2 * (0.46D2 * x + 0.50D2 + 0.13D2 * t22) * t3 * t57 - 0.32D2 / 0.9
     #D1 * t4 * t60 - 0.4D1 / 0.27D2 * t4 * t19 * t5 - 0.4D1 / 0.27D2 * 
     #t68 * t19 * t29 + 0.4D1 / 0.27D2 * (0.26D2 * x - 0.18D2 + 0.9D1 * 
     #t22) * t3 * t19 - 0.16D2 / 0.3D1 * t10 * t30 * t5 + 0.8D1 / 0.9D1 
     #* t4 * z2 * t5 + 0.2D1 / 0.27D2 * (0.124D3 * x + 0.69D2 * t22 - 0.
     #177D3) * t3 * t5 + 0.32D2 / 0.9D1 * t10 * t3 * t90 - 0.4D1 / 0.3D1
     # * t37 * t30 - 0.8D1 / 0.9D1 * (-0.6D1 + 0.3D1 * t22 + t48) * t3 *
     # z2 - 0.8D1 / 0.27D2 * t68 * z3 + 0.4D1 / 0.27D2 * (0.27D2 * x + 0
     #.160D3) * t9 * t3
	qq_n2_reg = t108
	end

c====================================================================
c
c		q1q2reg
c
c====================================================================	

      double precision function q1q2reg(z,wlo)
      implicit none 
	double precision q1q2_n2_reg
      double precision z
      integer wlo
	double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
	common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			q1q2reg = 0d0
		case(1)
			q1q2reg =  0d0 
		case(2)
			q1q2reg = WC0NNLO * q1q2_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			q1q2reg =   0d0
		case(1)
			q1q2reg =   0d0
		case(2)
			q1q2reg = WC0NNLO * q1q2_n2_reg(z)
		end select

	endif
      end


c=========================================================================	
      doubleprecision function q1q2_n2_reg(x)
	implicit double precision (t)
      double precision pi, z2, z3, L, Lt, Lr,x
      double precision Li2, Li3, S12, NF
      double precision s1,s2,s3,s4,s5,s6,s7,s8,s9,s10
      external Li2, Li3, S12
      common /xsection/ L, Lt, Lr, NF 
      common /consts/ pi, z2, z3       
      q1q2_n2_reg=((-4.D0/9.D0*(x+2)**2/x*dlog(x)
     #+8.D0/9.D0*(x+3)*(x-1)/x)
     #     *L**2
     #+(-16.D0/9.D0*(x+2)**2/x*Li2(x)-4.D0/9.D0*(x+2)**2/x*dlog(x)**2+4.
     #D0/9.D0*(-12+5*x**2+8*x)/x*dlog(x)-32.D0/9.D0*(x+3)*(x-1)/x*dlog(-
     #x+1)+16.D0/9.D0*(x+2)**2/x*z2+2.D0/3.D0*(5*x+17)*(x-1)/x)*L-8.D0/3
     #.D0*(x+2)**2/x*dlog(x)*Li2(x)-8.D0/9.D0*(4*x+x**2-6)/x*Li2(x)+32.D
     #0/9.D0*(x+2)**2/x*Li3(x)-32.D0/9.D0*(x+2)**2/x*S12(x)-4.D0/27.D0*(
     #x+2)**2/x*dlog(x)**3+8.D0/9.D0*(4*x-3+x**2)/x*dlog(x)**2-16.D0/3.D
     #0*(x+3)*(x-1)/x*dlog(-x+1)*dlog(x)+8.D0/9.D0*(x+2)**2/x*z2*dlog(x)
     #+2.D0/9.D0*(44*x-59+29*x**2)/x*dlog(x)+32.D0/9.D0*(x+3)*(x-1)/x*dl
     #og(-x+1)**2-4.D0/3.D0*(5*x+17)*(x-1)/x*dlog(-x+1)-8.D0/9.D0*(-6+3*
     #x**2+4*x)/x*z2+2.D0/9.D0*(11*x+105)*(x-1)/x)!*alphas**2
        return
      end	

c====================================================================
c====================================================================
c	
c			auxiliary functions 
c
c====================================================================
c====================================================================
C     returns Sum_q born_ampl(tau_q)  
      double complex function sborn_mass(QQQ)
      implicit none
      integer i
      double precision QQQ

      integer number_of_quarks
      double complex res,brn_q_ep0,xxx
      !double precision ZZq
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
	
      
cc      xxx=dcmplx(0d0,0d0)
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        res = res + Yq(i)*brn_q_ep0(Xq(i))*Wq(i)**2/64d0*(-3d0/4d0)
cc        print*,i,res,1d0-abs(xxx)**2/abs(res)**2
cc        xxx=res
      enddo  
    
      sborn_mass = res
      end 

c====================================================================

C     returns Sum_q born_ampl(tau_q)  where the sum runs over HEAVY QUARKS
c	HEAVY is defined to be larger than the heavy_quark_threshold below
      double complex function born_sum_heavy(QQQ)
      implicit none
      integer i
      double precision QQQ

      integer number_of_quarks
      double complex res,brn_q_ep0,xxx
      !double precision ZZq
	
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
      
      double precision heavy_quark_threshold
	
	heavy_quark_threshold=50d0
cc      xxx=dcmplx(0d0,0d0)
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        if (abs(Mq_square_complex(i)).gt.heavy_quark_threshold) then 
		!print*,"quark ",i," is heavy "
		res = res + Yq(i)*brn_q_ep0(Xq(i))*Wq(i)**2/64d0*(-3d0/4d0)
	  endif
cc        print*,i,res,1d0-abs(xxx)**2/abs(res)**2
cc        xxx=res
      enddo  
    
      born_sum_heavy = res
      end  
c====================================================================

C     returns born of Passarino, Actis, Sturm, Ucciratti 	
c	http://arxiv.org/abs/arXiv:0809.1301
c	We use their deltaEWK interpolated from their grid, and we 
c	need the born with top only, and with the values of top 
c	used there. This function is only used in 
c	calculate_wilson_coefficients @ higgs.F
      double complex function born_pass(QQQ)
      implicit none
      double precision QQQ,mtop_pass
	double complex brn_q_ep0,Wq,Xq
	
	mtop_pass = 170.9d0
	Wq = dcmplx(4d0*mtop_pass**2/QQQ**2,0d0)
	Xq = -Wq/(sqrt(1d0-Wq)+1d0)**2
	
	born_pass = brn_q_ep0(Xq)*Wq**2/64d0*(-3d0/4d0)
	!print*, born_pass
      end  


c====================================================================


C     returns Sum_q virtual_ampl(tau_q)  
      double complex function svirtual_mass(QQQ)
      implicit none
      integer i
      double precision QQQ
      
      double complex res,twol_q_fin,twol_q_fin_bon
      double precision myrealpart
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
	

      integer number_of_quarks

      
      !: note that we use here twol_q_fin_bon instead of twol_q_fin
	!: the difference is described in massive_ampls.F
	!: twol_q_fin_bon is known to have numerical (cancelation) issues for
	!: very heavy (mq>8TeV) quarks

      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks

		if (myrealpart(Xq(i)).gt.0.9999) then 
			print*,"[svirtual_mass]: warning, x_q is too large(",
     #							xq,") for quark ",i
		endif
        res = res + Yq(i)*twol_q_fin_bon(Xq(i))
      enddo  
    
      svirtual_mass = res
      end  

c====================================================================

C     returns Sum_q Aqqgh(tau_q)  necessary for reg_qqbar
      double complex function sum_Aqqgh(z,QQQ)
      implicit none
      integer i
      double precision QQQ,z
      integer number_of_quarks
      double complex res,twol_q_fin,mq
      !double precision ZZq
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
	
      double complex Aqqgh
      
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
	  mq = sqrt(Mq_square_complex(i))
        res = res + Yq(i)*Aqqgh(z,QQQ,Wq(i),mq)
     #      *Wq(i)*(3d0/4d0)
      enddo  
    
      sum_Aqqgh = res
      end  


c====================================================================
C     returns Sum_q Yq * m_q^2 Aq1(tau,z,lambda)  
      double complex function sum_over_quarks(func,z,lambda,QQQ)
      implicit none
      integer i
      double precision QQQ,z,lambda
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
      
	integer number_of_quarks
      double complex res,func,mq
      !double precision ZZq
      
      
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        mq  = sqrt(Mq_square_complex(i)) 
	  res = res + Yq(i)* 
     #      func(z,lambda,mq,QQQ)*
     #      Wq(i)
     #      *3d0/32d0/QQQ**2
      enddo  
    
      sum_over_quarks = res
      end


c==========================================================================
c
c           TESTING SUBROUTINES BELOW - REMOVE BY FINAL RELEASE
c
c--------------------------------------------------------------------------





c     test_limits compares the 1/2* z^4 * Sum_q{ | real_ggg_ampl1 |^2 } 
c     with (1-z+z^2) * born_ampl() 
c     at z=0.3, lambda=1e-10

      subroutine test_limits(QQQ)
      implicit none
      double precision QQQ
      double complex test_limit,test_mq,tau_q,test_born,triaf
      double complex sum_q_A1,sum_q_A2a,sborn_mass
      double complex sum_q_A2b,sum_q_A2c,sum_over_quarks  
      double precision z,lambda,tmp 
      external Aq1,Aq2a,Aq2b,Aq2c 


      


    ! testing whether the lambda->0 are still ok
      print*,"--------   limit testing \n"
      z=0.3d0
      lambda=1.d-10
      
      
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit
      
    ! testing whether the lambda ->1 are still ok
      print*,"--------   limit testing \n"
      z=0.03d0
      lambda=1-1d-10
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit      
      ! testing whether the lambda ->1 are still ok
      print*,"-------- z->1  limit testing \n"
      z=0.99999d0
      lambda=1-1d-10
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit  
c     print*,"QQQ=",QQQ,z,test_limit   
      stop
      
      end        
      
      
    
      subroutine virtual_11_over_2_test()
      implicit none
      double complex twol_q_fin,tau_q,xq,brn_q_ep0,born,two_loop_fin
	double complex twol_q_fin_bon,bonciani
      integer i
      tau_q = dcmplx(0.5d0,0d0)
      
      do i=1,20
		tau_q = 0.5d0 + (i-1.0)*100d0
		xq =  -tau_q/(sqrt(1d0-tau_q)+1d0)**2
		two_loop_fin = twol_q_fin(-xq)/64d0/8d0!*(3d0/4d0)
		born = brn_q_ep0(xq)*tau_q**2/64d0*(-3d0/4d0)
		bonciani = twol_q_fin_bon(xq)
		!print*,"***"
		!print*,"tau=",tau_q," x=",xq
		!print*,"born =",born
c		print*,"tau=",tau_q,"\t2loop=",two_loop_fin
		!print*,"11*4/3*born=",11d0*4d0/3d0*born
c		print*,!"mt=",dble(sqrt(tau_q*120d0**2)/2d0),
c     #	" tau=",tau_q,
      	print*,"tau=",tau_q,"\tbonciani=",bonciani,11d0/2d0*born
      
      enddo
	do i=1,20
		tau_q = tau_q*10d0
		xq =  -tau_q/(sqrt(1d0-tau_q)+1d0)**2
		two_loop_fin = twol_q_fin(-xq)/64d0/8d0!*(3d0/4d0)
		born = brn_q_ep0(xq)*tau_q**2/64d0*(-3d0/4d0)
		bonciani = twol_q_fin_bon(xq)*(-2d0/3d0)
		!print*,"***"
		!print*,"tau=",tau_q," x=",xq
		!print*,"born =",born
c		print*,"tau=",tau_q,"\t2loop=",two_loop_fin
		!print*,"11*4/3*born=",11d0*4d0/3d0*born

      	print*,"tau=",tau_q,"\tbonciani=",bonciani,11d0/2d0*born
      
      enddo
      end

      
