

C ----- Receives as(Mz) -----------------------------
C ----- RETURNS(as(mu)/Pi)---------------------------

      double precision function SSC(mu,asZ,porder)
      implicit none
      double precision mu,asZ,step, b0,b1,b2, incr,as0
      double precision Mz, as
      character*60 porder
      integer i
	! Nf = 5 **************** <---------
      b0= 1.916666667
      b1=1.260869565
      b2=1.474788647

      as0=asZ/3.1415926D0
      Mz=91.187D0
      

c      step=dlog(mu**2/Mz**2)/100
      step=dlog(mu**2/Mz**2)/100000
      !do i=1,100
       do i=1,100000 
         if (porder.EQ.'NNLO') then
            incr = step*b0*as0**2*(1.D0+b1*as0 + b2*as0**2 )            
         elseif (porder.EQ.'NLO') then
            incr = step*b0*as0**2*(1.D0+b1*as0 )
         elseif (porder.EQ.'LO') then
            incr = step*b0*as0**2
	   else
		print*,"[SSC]Error unrecognized perturbative order: ",porder
		incr=0d0  
         endif

         as=as0 - incr
         as0 = as
      enddo
 
      SSC=as
 
      RETURN
      end

c--------------- yukawa bottom
      double precision function yukawa_b(mur, iord, mur0, 
     $                  lambdab0, nf,asZ)
      implicit none
      double precision mur
      character*60 iord
      double precision mur0
      double precision lambdab0
      double precision nf
      double precision b0
      double precision b1
      double precision b2
      double precision g0
      double precision g1
      double precision g2
      double precision retval
      double precision as_mr,as_m0,asZ,SSC
      double precision expr1
      double precision expr2
     
      as_m0 = SSC(mur0,asZ,iord)
      as_mr = SSC(mur,asZ,iord)
     
      b0 = 0.11D2 / 0.4D1 - nf / 0.6D1
      b1 = 0.51D2 / 0.8D1 - 0.19D2 / 0.24D2 * nf
      b2 = 0.2857D4 / 0.128D3 - 0.5033D4 / 0.1152D4 * nf + 0.325D3 / 0
     $.3456D4 * nf ** 2
      g0 = 0.10D1
      g1 = 0.101D3 / 0.24D2 - 0.5D1 / 0.36D2 * nf
      g2 = 0.1249D4 / 0.64D2 - 0.2284121493373735D1 * nf - 0.35D2 / 0.
     $1296D4 * nf ** 2
      if (iord .eq. 'LO') then
         retval = lambdab0 * (as_mr / as_m0) ** (g0 / b0)
      else if (iord .eq.'NLO') then
         retval = lambdab0 * (as_mr / as_m0) ** (g0 / b0)
     $* (0.1D1 + (g1 / b0 - b1 * g0 / b0 ** 2) * as_mr 
     #  ) / (0.1D1 + (g1 / b0 - b1 * g0 / b0 ** 2) * as_m0
     # )
      else if (iord .eq. 'NNLO') then
         expr1 = 0.1D1 + (g1 / b0 - b1 * g0 / b0 ** 2) * as_mr 
     # + 0.5D0 * ((g1 / b0 - b1 * g0 / b0 ** 2) ** 2
     #+ g2 / b0 - g1 * b1 / b0 ** 2 + b1 * b1 * g0 / b0 ** 3 - b2 * g0
     #/ b0 ** 2) * as_mr ** 2 
         expr2 = 0.1D1 + (g1 / b0 - b1 * g0 / b0 ** 2) * as_m0 
     # + 0.5D0 * ((g1 / b0 - b1 * g0 / b0 ** 2) **
     #2 + g2 / b0 - g1 * b1 / b0 ** 2 + b1 * b1 * g0 / b0 ** 3 - b2 * g0
     #/ b0 ** 2) * as_m0 ** 2 
         retval = lambdab0 * (as_mr / as_m0) ** (g0 / b0)
     #* expr1 / expr2
      else
		print*,"[yukawa_b] Error unrecognized perturbative order: ",iord
		retval=0d0
      end if
      yukawa_b = retval
      return
      end
     
     
     
