
	subroutine my_interpolated_pdf(x,alpha_set_index, 
     &			member_set_index,
     &			upv,dnv,usea,dsea,str,
     &			chm,bot,glu)
      implicit none
      integer alpha_set_index,member_set_index
      double precision x,upv,dnv,usea,dsea,str,chm,bot,glu
	double precision up_total,down_total
	
	call C_values(x,alpha_set_index,member_set_index,2,up_total)
	call C_values(x,alpha_set_index,member_set_index,-2,usea)
	upv=up_total - usea
	call C_values(x,alpha_set_index,member_set_index,1,down_total)
	call C_values(x,alpha_set_index,member_set_index,-1,dsea)
	dnv=down_total - dsea
	call C_values(x,alpha_set_index,member_set_index,3,str)
	call C_values(x,alpha_set_index,member_set_index,4,chm)
	call C_values(x,alpha_set_index,member_set_index,5,bot)
	call C_values(x,alpha_set_index,member_set_index,0,glu)

	end subroutine
	
	
	
c---------------------------------------------------------------------------
c     retrieves the pdfs using the LHAPDf routines:
c------------------------------------------------------------------------------
      subroutine my_lha_pdfs(x,muf,alpha_set_index, 
     &			member_set_index,
     &			upv,dnv,usea,dsea,str,
     &			chm,bot,glu)
      implicit none    
	integer alpha_set_index,member_set_index
      double precision x,upv,dnv,usea,dsea,str,chm,bot,glu
      doubleprecision muf
      integer iset
      double precision f(-6:6)
      
      iset=alpha_set_index! dummy statement
	iset=member_set_index!dummy statement
      call evolvePDF(x,muf,f)
	upv = f(2) - f(-2)
	usea = f(-2)
	dnv = f(1) - f(-1)
	dsea = f(-1)
	str = f(3)
	chm = f(4)
	bot = f(5)
	glu = f(0)
      
	end subroutine


	
	
	subroutine C_values(x,alpha_set_index,member_set_index,
     $flavour_index,my_value)
	implicit none
	integer alpha_set_index,member_set_index,flavour_index,L
	double precision my_value,x
	include 'pdf_eigen_alpha.h'
	DOUBLEPRECISION HH,lambda,rr
	
	
	
	hh = Np*(Np-1)/(1D0-XMIN)
      lambda = (x-XMIN)*hh
      if(lambda.lt.0d0) then
         write(6,*) 'WARNING: x out of fitting range: x=',x,
     &		' xmin=',xmin
         lambda=0d0
      endif
      rr = 0.5d0*(1.0d0+dsqrt(1+4.d0*lambda))
      L =int(rr) 
      
	my_value = (
     &	C(alpha_set_index,member_set_index,3,L,flavour_index)
     &    + x * C(alpha_set_index,member_set_index,2,L,flavour_index) 
     &    + x**2 * C(alpha_set_index,member_set_index,1,L,flavour_index) 
     &	 )
	
	end subroutine


c---------------------------------------------------------------------------
c     evolves a_s and yukawa for each PDF member to mur 
c------------------------------------------------------------------------------
 
	subroutine evolve_as_yukawa(mur,porder,Ngrids)
	implicit none
	double precision mur,SSC,yukawa_b
	character*60 porder
	integer Ngrids,imember
	double precision mu_bot0,lambda0,active_flavours
	!: alph_yukawa communicates with Higgs.F inside the integration loop
	include 'alpha_yukawa.h'
	!
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     & number_of_quarks   
      integer  number_of_quarks
	!
	double precision Gf
	common /comGf/ Gf
	!
	!: running of yukawa_b , i.e. of m_b
      !: mur0 initial scale for m_b
      !: mbot @ 10 GeV from arXiv:hep-ph/0705.2335 
      !: mur0 and 
	double precision mu_c_0,yukawa_charm
	! original_masses : necessary for evolution at different orders
	double precision original_masses(100)
	common /OriginalMasses/ original_masses
	
	mu_bot0= 10d0
	lambda0 = dsqrt(dsqrt(2d0)*Gf)*original_masses(2)
	active_flavours=5
      
	print*,"Running of coupling constants and masses."     
c	print*,"Ngrids = ",Ngrids
	do imember=0,Ngrids
		alphas(imember) = SSC(mur,alphaMz(imember),porder)
		yukawa_bb(imember) = yukawa_b(mur,porder,mu_bot0,lambda0,
     $		active_flavours,alphaMz(imember) )
c		write(*,"(A,I2,5(A,(1F8.4,' ')))"),
c     $		" Running of couplings and masses :",imember,"| a_s(mz)=",
c     $		alphaMz(imember),
c     $	"->",alphas(imember)*3.141592654d0
c     $	,"| y_b =",yukawa_bb(imember)
c     $	,"| mb  =",original_masses(2)," -> ",
c     $		yukawa_bb(imember)/0.004061433931d0
		
      enddo
	if (number_of_quarks.gt.1) then 
			double_mq(2) = yukawa_bb(0) /0.004061433931d0 
			Mq_square_complex(2)=dcmplx(double_mq(2)**2,-1d-16)
			! using imember=0 evolved yukawa
			!print*,imember," ",double_mq(2),yukawa_bb(0)
	endif
	
	if ((number_of_quarks.gt.2).and.(double_mq(3).lt.10d0)) then 
		!charm quark case
		mu_c_0=3d0
		lambda0 = dsqrt(dsqrt(2d0)*Gf)*original_masses(3)
		active_flavours=4
		
		yukawa_charm=yukawa_b(mur,porder,mu_c_0,lambda0,
     $				active_flavours,alphaMz(0))
		double_mq(3) = yukawa_charm /0.004061433931d0 
		Mq_square_complex(3)=dcmplx(double_mq(3)**2,-1d-16)
		print*,"evolved charm mass: ",original_masses," -> ",
     $		double_mq(3)	
		
			! using imember=0 evolved yukawa
			!print*,imember," ",double_mq(2),yukawa_bb(0)
		endif
	
	end










               
   
